/* zf11d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b2 = 10.;
static integer c__11 = 11;

/* Subroutine */ int zf11d_c(D_fp f, doublereal *a, doublereal *b,
        doublereal *eps, integer *ndig, integer *itmax, doublereal *root,
        integer *ierr)
{
    /* Initialized data */

    static doublereal xmin = 9e-18;

    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Builtin functions */
    double pow_di(doublereal *, integer *);

    /* Local variables */
    static integer nsig;
    static doublereal epsp, xapp, fxapp;
    extern /* Subroutine */ int utzf11_c(integer *, integer *);
    static integer ic;
    static doublereal xl, xr, fxl, fxr;

    xl = *a;
    xr = *b;
    nsig = *ndig;
    *ierr = 0;
    ic = 0;
    if (*ndig == 0 && *eps == 0.) {
        nsig = 5;
    }
    i__1 = -nsig;
    epsp = pow_di(&c_b2, &i__1);
    fxl = (*f)(&xl);
    fxr = (*f)(&xr);
    xapp = xl;
    if ((d__1 = fxl * fxr) < 0.) {
        goto L3;
    } else if (d__1 == 0) {
        goto L2;
    } else {
        goto L1;
    }
L1:
    *ierr = 66;
    goto L8;
L2:
    xapp = xr;
    if (fxl == 0.) {
        xapp = xl;
    }
    goto L8;
L3:
    if ((d__1 = fxl - fxr, abs(d__1)) <= xmin) {
        goto L8;
    }
    xapp = xl + fxl * (xr - xl) / (fxl - fxr);
    fxapp = (*f)(&xapp);
    if (abs(fxapp) > abs(*eps)) {
        goto L4;
    }
    goto L8;
L4:
    if (fxapp * fxl > 0.) {
        goto L5;
    }
    xr = xapp;
    fxr = fxapp;
    goto L6;
L5:
    xl = xapp;
    fxl = fxapp;
L6:
    if (nsig == 0) {
        goto L7;
    }
    if (xr - xl > epsp * abs(xr)) {
        goto L7;
    }
    goto L8;
L7:
    ++ic;
    if (ic <= *itmax) {
        goto L3;
    }
    *ierr = 65;
L8:
    *itmax = ic;
    if (*ierr != 0) {
        goto L9;
    }
    *root = xapp;
    goto L10;
L9:
    utzf11_c(ierr, &c__11);
L10:
    return 0;
} /* zf11d_c */
